diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/tests/test-ns3.py ns-3.41/utils/tests/test-ns3.py
--- ns-3.40/utils/tests/test-ns3.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/tests/test-ns3.py	2024-02-09 14:44:08.633795300 -0800
@@ -43,10 +43,14 @@
 
 # Cmake commands
 num_threads = max(1, os.cpu_count() - 1)
-cmake_build_project_command = "cmake --build . -j".format(ns3_path=ns3_path)
-cmake_build_target_command = partial("cmake --build . -j {jobs} --target {target}".format,
-                                     jobs=num_threads
-                                     )
+cmake_build_project_command = "cmake --build {cmake_cache} -j".format(
+    ns3_path=ns3_path, cmake_cache=os.path.abspath(os.path.join(ns3_path, "cmake-cache"))
+)
+cmake_build_target_command = partial(
+    "cmake --build {cmake_cache} -j {jobs} --target {target}".format,
+    jobs=num_threads,
+    cmake_cache=os.path.abspath(os.path.join(ns3_path, "cmake-cache")),
+)
 win32 = sys.platform == "win32"
 platform_makefiles = "MinGW Makefiles" if win32 else "Unix Makefiles"
 ext = ".exe" if win32 else ""
@@ -95,10 +99,10 @@
         arguments = [program]
 
     if args != "":
-        arguments.extend(re.findall("(?:\".*?\"|\S)+", args))  # noqa
+        arguments.extend(re.findall('(?:".*?"|\S)+', args))  # noqa
 
     for i in range(len(arguments)):
-        arguments[i] = arguments[i].replace("\"", "")
+        arguments[i] = arguments[i].replace('"', "")
 
     # Forward environment variables used by the ns3 script
     current_env = os.environ.copy()
@@ -114,10 +118,14 @@
         stdout=subprocess.PIPE,
         stderr=subprocess.PIPE,
         cwd=cwd,  # run process from the ns-3-dev path
-        env=current_env
+        env=current_env,
     )
     # Return (error code, stdout and stderr)
-    return ret.returncode, ret.stdout.decode(sys.stdout.encoding), ret.stderr.decode(sys.stderr.encoding)
+    return (
+        ret.returncode,
+        ret.stdout.decode(sys.stdout.encoding),
+        ret.stderr.decode(sys.stderr.encoding),
+    )
 
 
 def get_programs_list():
@@ -143,7 +151,7 @@
     @param lib_outdir: path containing libraries
     @return list of built libraries.
     """
-    libraries = glob.glob(lib_outdir + '/*', recursive=True)
+    libraries = glob.glob(lib_outdir + "/*", recursive=True)
     return list(filter(lambda x: "scratch-nested-subdir-lib" not in x, libraries))
 
 
@@ -153,7 +161,7 @@
     @param outdir: path containing headers
     @return list of headers.
     """
-    return glob.glob(outdir + '/**/*.h', recursive=True)
+    return glob.glob(outdir + "/**/*.h", recursive=True)
 
 
 def read_lock_entry(entry):
@@ -215,11 +223,13 @@
 
         # Create Docker client instance and start it
         ## The Python-on-whales container instance
-        self.container = docker.run(containerName,
-                                    interactive=True, detach=True,
-                                    tty=False,
-                                    volumes=[(ns3_path, "/ns-3-dev")]
-                                    )
+        self.container = docker.run(
+            containerName,
+            interactive=True,
+            detach=True,
+            tty=False,
+            volumes=[(ns3_path, "/ns-3-dev")],
+        )
 
         # Redefine the execute command of the container
         def split_exec(docker_container, cmd):
@@ -285,7 +295,9 @@
                 continue
 
             # Open the examples CMakeLists.txt and read it
-            with open(os.path.join(example_directory, "CMakeLists.txt"), "r", encoding="utf-8") as f:
+            with open(
+                os.path.join(example_directory, "CMakeLists.txt"), "r", encoding="utf-8"
+            ) as f:
                 cmake_contents = f.read()
 
             # For each file, check if it is in the CMake contents
@@ -328,8 +340,9 @@
                     unused_sources.add(file)
 
         # Remove temporary exceptions
-        exceptions = ["win32-system-wall-clock-ms.cc",  # Should be removed with MR784
-                      ]
+        exceptions = [
+            "win32-system-wall-clock-ms.cc",  # Should be removed with MR784
+        ]
         for exception in exceptions:
             for unused_source in unused_sources:
                 if os.path.basename(unused_source) == exception:
@@ -394,20 +407,25 @@
 
             module_name = os.path.relpath(path, ns3_path)
             module_name_nodir = module_name.replace("src/", "").replace("contrib/", "")
-            modules[module_name_nodir] = {"sources": set(),
-                                          "headers": set(),
-                                          "libraries": set(),
-                                          "included_headers": set(),
-                                          "included_libraries": set(),
-                                          }
+            modules[module_name_nodir] = {
+                "sources": set(),
+                "headers": set(),
+                "libraries": set(),
+                "included_headers": set(),
+                "included_libraries": set(),
+            }
 
             # Separate list of source files and header files
             for line in cmake_contents:
-                base_name = os.path.basename(line[:-1])
-                if not os.path.exists(os.path.join(path, line.strip())):
+                source_file_path = re.findall(r"\b(?:[^\s]+\.[ch]{1,2})\b", line.strip())
+                if not source_file_path:
+                    continue
+                source_file_path = source_file_path[0]
+                base_name = os.path.basename(source_file_path)
+                if not os.path.exists(os.path.join(path, source_file_path)):
                     continue
 
-                if ".h" in line:
+                if ".h" in source_file_path:
                     # Register all module headers as module headers and sources
                     modules[module_name_nodir]["headers"].add(base_name)
                     modules[module_name_nodir]["sources"].add(base_name)
@@ -415,24 +433,34 @@
                     # Register the header as part of the current module
                     headers_to_modules[base_name] = module_name_nodir
 
-                if ".cc" in line:
+                if ".cc" in source_file_path:
                     # Register the source file as part of the current module
                     modules[module_name_nodir]["sources"].add(base_name)
 
-                if ".cc" in line or ".h" in line:
+                if ".cc" in source_file_path or ".h" in source_file_path:
                     # Extract includes from headers and source files and then add to a list of included headers
-                    source_file = os.path.join(ns3_path, module_name, line.strip())
+                    source_file = os.path.join(ns3_path, module_name, source_file_path)
                     with open(source_file, "r", encoding="utf-8") as f:
                         source_contents = f.read()
-                    modules[module_name_nodir]["included_headers"].update(map(lambda x: x.replace("ns3/", ""),
-                                                                              re.findall("#include.*[\"|<](.*)[\"|>]",
-                                                                                         source_contents)
-                                                                              )
-                                                                          )
+                    modules[module_name_nodir]["included_headers"].update(
+                        map(
+                            lambda x: x.replace("ns3/", ""),
+                            re.findall('#include.*["|<](.*)["|>]', source_contents),
+                        )
+                    )
                     continue
 
             # Extract libraries linked to the module
-            modules[module_name_nodir]["libraries"].update(re.findall("\\${lib(.*)}", "".join(cmake_contents)))
+            modules[module_name_nodir]["libraries"].update(
+                re.findall("\${lib(.*?)}", "".join(cmake_contents))
+            )
+            modules[module_name_nodir]["libraries"] = list(
+                filter(
+                    lambda x: x
+                    not in ["raries_to_link", module_name_nodir, module_name_nodir + "-obj"],
+                    modules[module_name_nodir]["libraries"],
+                )
+            )
 
         # Now that we have all the information we need, check if we have all the included libraries linked
         all_project_headers = set(headers_to_modules.keys())
@@ -441,20 +469,70 @@
         print(file=sys.stderr)
         for module in sorted(modules):
             external_headers = modules[module]["included_headers"].difference(all_project_headers)
-            project_headers_included = modules[module]["included_headers"].difference(external_headers)
+            project_headers_included = modules[module]["included_headers"].difference(
+                external_headers
+            )
             modules[module]["included_libraries"] = set(
-                [headers_to_modules[x] for x in project_headers_included]).difference(
-                {module})
+                [headers_to_modules[x] for x in project_headers_included]
+            ).difference({module})
 
             diff = modules[module]["included_libraries"].difference(modules[module]["libraries"])
-            if len(diff) > 0:
-                print("Module %s includes modules that are not linked: %s" % (module, ", ".join(list(diff))),
-                      file=sys.stderr)
-                sys.stderr.flush()
-            # Uncomment this to turn into a real test
-            # self.assertEqual(len(diff), 0,
-            #                 msg="Module %s includes modules that are not linked: %s" % (module, ", ".join(list(diff)))
-            #                 )
+
+        # Find graph with least amount of edges based on included_libraries
+        def recursive_check_dependencies(checked_module):
+            # Remove direct explicit dependencies
+            for module_to_link in modules[checked_module]["included_libraries"]:
+                modules[checked_module]["included_libraries"] = set(
+                    modules[checked_module]["included_libraries"]
+                ) - set(modules[module_to_link]["included_libraries"])
+
+            for module_to_link in modules[checked_module]["included_libraries"]:
+                recursive_check_dependencies(module_to_link)
+
+            # Remove unnecessary implicit dependencies
+            def is_implicitly_linked(searched_module, current_module):
+                if len(modules[current_module]["included_libraries"]) == 0:
+                    return False
+                if searched_module in modules[current_module]["included_libraries"]:
+                    return True
+                for module in modules[current_module]["included_libraries"]:
+                    if is_implicitly_linked(searched_module, module):
+                        return True
+                return False
+
+            from itertools import combinations
+
+            implicitly_linked = set()
+            for dep1, dep2 in combinations(modules[checked_module]["included_libraries"], 2):
+                if is_implicitly_linked(dep1, dep2):
+                    implicitly_linked.add(dep1)
+                if is_implicitly_linked(dep2, dep1):
+                    implicitly_linked.add(dep2)
+
+            modules[checked_module]["included_libraries"] = (
+                set(modules[checked_module]["included_libraries"]) - implicitly_linked
+            )
+
+        for module in modules:
+            recursive_check_dependencies(module)
+
+        # Print findings
+        for module in sorted(modules):
+            if module == "test":
+                continue
+            minimal_linking_set = ", ".join(modules[module]["included_libraries"])
+            unnecessarily_linked = ", ".join(
+                set(modules[module]["libraries"]) - set(modules[module]["included_libraries"])
+            )
+            missing_linked = ", ".join(
+                set(modules[module]["included_libraries"]) - set(modules[module]["libraries"])
+            )
+            if unnecessarily_linked:
+                print(f"Module '{module}' unnecessarily linked: {unnecessarily_linked}.")
+            if missing_linked:
+                print(f"Module '{module}' missing linked: {missing_linked}.")
+            if unnecessarily_linked or missing_linked:
+                print(f"Module '{module}' minimal linking set: {minimal_linking_set}.")
         self.assertTrue(True)
 
 
@@ -475,13 +553,12 @@
         @return None
         """
         if not NS3StyleTestCase.starting_diff:
-
             if shutil.which("git") is None:
                 self.skipTest("Git is not available")
 
             try:
-                from git import Repo  # noqa
                 import git.exc  # noqa
+                from git import Repo  # noqa
             except ImportError:
                 self.skipTest("GitPython is not available")
 
@@ -604,7 +681,9 @@
         Test the debug build
         @return None
         """
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" -d debug --enable-verbose")
+        return_code, stdout, stderr = run_ns3(
+            'configure -G "{generator}" -d debug --enable-verbose'
+        )
         self.assertEqual(return_code, 0)
         self.assertIn("Build profile                 : debug", stdout)
         self.assertIn("Build files have been written to", stdout)
@@ -623,7 +702,7 @@
         Test the release build
         @return None
         """
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" -d release")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" -d release')
         self.assertEqual(return_code, 0)
         self.assertIn("Build profile                 : release", stdout)
         self.assertIn("Build files have been written to", stdout)
@@ -633,7 +712,9 @@
         Test the optimized build
         @return None
         """
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" -d optimized --enable-verbose")
+        return_code, stdout, stderr = run_ns3(
+            'configure -G "{generator}" -d optimized --enable-verbose'
+        )
         self.assertEqual(return_code, 0)
         self.assertIn("Build profile                 : optimized", stdout)
         self.assertIn("Build files have been written to", stdout)
@@ -652,7 +733,7 @@
         Test a build type with a typo
         @return None
         """
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" -d Optimized")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" -d Optimized')
         self.assertEqual(return_code, 2)
         self.assertIn("invalid choice: 'Optimized'", stderr)
 
@@ -661,7 +742,7 @@
         Test a build type with another typo
         @return None
         """
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" -d OPTIMIZED")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" -d OPTIMIZED')
         self.assertEqual(return_code, 2)
         self.assertIn("invalid choice: 'OPTIMIZED'", stderr)
 
@@ -673,31 +754,37 @@
         return_code, _, _ = run_ns3("clean")
         self.assertEqual(return_code, 0)
 
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --dry-run -d debug")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --dry-run -d debug')
         self.assertEqual(return_code, 0)
         self.assertIn(
             "-DCMAKE_BUILD_TYPE=debug -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=ON -DNS3_NATIVE_OPTIMIZATIONS=OFF",
-            stdout)
+            stdout,
+        )
 
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --dry-run -d debug --disable-asserts --disable-logs --disable-werror")
+            'configure -G "{generator}" --dry-run -d debug --disable-asserts --disable-logs --disable-werror'
+        )
         self.assertEqual(return_code, 0)
         self.assertIn(
             "-DCMAKE_BUILD_TYPE=debug -DNS3_NATIVE_OPTIMIZATIONS=OFF -DNS3_ASSERT=OFF -DNS3_LOG=OFF -DNS3_WARNINGS_AS_ERRORS=OFF",
-            stdout)
+            stdout,
+        )
 
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --dry-run")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --dry-run')
         self.assertEqual(return_code, 0)
         self.assertIn(
             "-DCMAKE_BUILD_TYPE=default -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=OFF -DNS3_NATIVE_OPTIMIZATIONS=OFF",
-            stdout)
+            stdout,
+        )
 
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --dry-run --enable-asserts --enable-logs --enable-werror")
+            'configure -G "{generator}" --dry-run --enable-asserts --enable-logs --enable-werror'
+        )
         self.assertEqual(return_code, 0)
         self.assertIn(
             "-DCMAKE_BUILD_TYPE=default -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_NATIVE_OPTIMIZATIONS=OFF -DNS3_ASSERT=ON -DNS3_LOG=ON -DNS3_WARNINGS_AS_ERRORS=ON",
-            stdout)
+            stdout,
+        )
 
 
 class NS3BaseTestCase(unittest.TestCase):
@@ -705,16 +792,18 @@
     Generic test case with basic function inherited by more complex tests.
     """
 
-    def config_ok(self, return_code, stdout):
+    def config_ok(self, return_code, stdout, stderr):
         """!
         Check if configuration for release mode worked normally
         @param return_code: return code from CMake
         @param stdout: output from CMake.
+        @param stderr: error from CMake.
         @return None
         """
         self.assertEqual(return_code, 0)
         self.assertIn("Build profile                 : release", stdout)
         self.assertIn("Build files have been written to", stdout)
+        self.assertNotIn("uninitialized variable", stderr)
 
     def setUp(self):
         """!
@@ -730,8 +819,10 @@
 
         # Reconfigure from scratch before each test
         run_ns3("clean")
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" -d release --enable-verbose")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            'configure -G "{generator}" -d release --enable-verbose'
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # Check if .lock-ns3 exists, then read to get list of executables.
         self.assertTrue(os.path.exists(ns3_lock_filename))
@@ -761,19 +852,20 @@
         Test enabling and disabling examples
         @return None
         """
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-examples")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --enable-examples')
 
         # This just tests if we didn't break anything, not that we actually have enabled anything.
-        self.config_ok(return_code, stdout)
+        self.config_ok(return_code, stdout, stderr)
 
         # If nothing went wrong, we should have more executables in the list after enabling the examples.
+        ## ns3_executables
         self.assertGreater(len(get_programs_list()), len(self.ns3_executables))
 
         # Now we disabled them back.
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-examples")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --disable-examples')
 
         # This just tests if we didn't break anything, not that we actually have enabled anything.
-        self.config_ok(return_code, stdout)
+        self.config_ok(return_code, stdout, stderr)
 
         # Then check if they went back to the original list.
         self.assertEqual(len(get_programs_list()), len(self.ns3_executables))
@@ -784,8 +876,8 @@
         @return None
         """
         # Try enabling tests
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-tests")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --enable-tests')
+        self.config_ok(return_code, stdout, stderr)
 
         # Then try building the libcore test
         return_code, stdout, stderr = run_ns3("build core-test")
@@ -795,8 +887,8 @@
         self.assertIn("Built target libcore-test", stdout)
 
         # Now we disabled the tests
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-tests")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --disable-tests')
+        self.config_ok(return_code, stdout, stderr)
 
         # Now building the library test should fail
         return_code, stdout, stderr = run_ns3("build core-test")
@@ -811,23 +903,28 @@
         @return None
         """
         # Try filtering enabled modules to network+Wi-Fi and their dependencies
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-modules='network;wifi'")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            "configure -G \"{generator}\" --enable-modules='network;wifi'"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have fewer modules
         enabled_modules = get_enabled_modules()
+        ## ns3_modules
         self.assertLess(len(get_enabled_modules()), len(self.ns3_modules))
         self.assertIn("ns3-network", enabled_modules)
         self.assertIn("ns3-wifi", enabled_modules)
 
         # Try enabling only core
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-modules='core'")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            "configure -G \"{generator}\" --enable-modules='core'"
+        )
+        self.config_ok(return_code, stdout, stderr)
         self.assertIn("ns3-core", get_enabled_modules())
 
         # Try cleaning the list of enabled modules to reset to the normal configuration.
         return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-modules=''")
-        self.config_ok(return_code, stdout)
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have the same amount of modules that we had when we started.
         self.assertEqual(len(get_enabled_modules()), len(self.ns3_modules))
@@ -838,8 +935,10 @@
         @return None
         """
         # Try filtering disabled modules to disable lte and modules that depend on it.
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-modules='lte;wimax'")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            "configure -G \"{generator}\" --disable-modules='lte;wimax'"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have fewer modules.
         enabled_modules = get_enabled_modules()
@@ -849,7 +948,7 @@
 
         # Try cleaning the list of enabled modules to reset to the normal configuration.
         return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-modules=''")
-        self.config_ok(return_code, stdout)
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have the same amount of modules that we had when we started.
         self.assertEqual(len(get_enabled_modules()), len(self.ns3_modules))
@@ -860,8 +959,10 @@
         @return None
         """
         # Try filtering enabled modules to network+Wi-Fi and their dependencies.
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-modules='network,wifi'")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            "configure -G \"{generator}\" --enable-modules='network,wifi'"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have fewer modules.
         enabled_modules = get_enabled_modules()
@@ -871,7 +972,7 @@
 
         # Try cleaning the list of enabled modules to reset to the normal configuration.
         return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-modules=''")
-        self.config_ok(return_code, stdout)
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have the same amount of modules that we had when we started.
         self.assertEqual(len(get_enabled_modules()), len(self.ns3_modules))
@@ -882,8 +983,10 @@
         @return None
         """
         # Try filtering disabled modules to disable lte and modules that depend on it.
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-modules='lte,mpi'")
-        self.config_ok(return_code, stdout)
+        return_code, stdout, stderr = run_ns3(
+            "configure -G \"{generator}\" --disable-modules='lte,mpi'"
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have fewer modules.
         enabled_modules = get_enabled_modules()
@@ -893,7 +996,7 @@
 
         # Try cleaning the list of enabled modules to reset to the normal configuration.
         return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --disable-modules=''")
-        self.config_ok(return_code, stdout)
+        self.config_ok(return_code, stdout, stderr)
 
         # At this point we should have the same amount of modules that we had when we started.
         self.assertEqual(len(get_enabled_modules()), len(self.ns3_modules))
@@ -928,18 +1031,18 @@
                                     "
 
             ## map ns3rc templates to types # noqa
-            ns3rc_templates = {
-                "python": ns3rc_python_template,
-                "cmake": ns3rc_cmake_template
-            }
+            ns3rc_templates = {"python": ns3rc_python_template, "cmake": ns3rc_cmake_template}
 
             def __init__(self, type_ns3rc):
+                ## type contains the ns3rc variant type (deprecated python-based or current cmake-based)
                 self.type = type_ns3rc
 
             def format(self, **args):
                 # Convert arguments from python-based ns3rc format to CMake
                 if self.type == "cmake":
-                    args["modules"] = args["modules"].replace("'", "").replace("\"", "").replace(",", " ")
+                    args["modules"] = (
+                        args["modules"].replace("'", "").replace('"', "").replace(",", " ")
+                    )
                     args["examples"] = "ON" if args["examples"] == "True" else "OFF"
                     args["tests"] = "ON" if args["tests"] == "True" else "OFF"
 
@@ -961,8 +1064,8 @@
                 f.write(ns3rc_template.format(modules="'lte'", examples="False", tests="True"))
 
             # Reconfigure.
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
-            self.config_ok(return_code, stdout)
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+            self.config_ok(return_code, stdout, stderr)
 
             # Check.
             enabled_modules = get_enabled_modules()
@@ -976,8 +1079,8 @@
                 f.write(ns3rc_template.format(modules="'wifi'", examples="True", tests="False"))
 
             # Reconfigure
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
-            self.config_ok(return_code, stdout)
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+            self.config_ok(return_code, stdout, stderr)
 
             # Check
             enabled_modules = get_enabled_modules()
@@ -988,11 +1091,15 @@
 
             # Replace the ns3rc file with multiple modules
             with open(ns3rc_script, "w", encoding="utf-8") as f:
-                f.write(ns3rc_template.format(modules="'core','network'", examples="True", tests="False"))
+                f.write(
+                    ns3rc_template.format(
+                        modules="'core','network'", examples="True", tests="False"
+                    )
+                )
 
             # Reconfigure
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
-            self.config_ok(return_code, stdout)
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+            self.config_ok(return_code, stdout, stderr)
 
             # Check
             enabled_modules = get_enabled_modules()
@@ -1006,19 +1113,28 @@
             # in various different ways and with comments
             with open(ns3rc_script, "w", encoding="utf-8") as f:
                 if ns3rc_type == "python":
-                    f.write(ns3rc_template.format(modules="""'core', #comment
+                    f.write(
+                        ns3rc_template.format(
+                            modules="""'core', #comment
                     'lte',
                     #comment2,
                     #comment3
-                    'network', 'internet','wimax'""", examples="True", tests="True"))
+                    'network', 'internet','wimax'""",
+                            examples="True",
+                            tests="True",
+                        )
+                    )
                 else:
-                    f.write(ns3rc_template.format(modules="'core', 'lte', 'network', 'internet', 'wimax'",
-                                                  examples="True",
-                                                  tests="True")
-                            )
+                    f.write(
+                        ns3rc_template.format(
+                            modules="'core', 'lte', 'network', 'internet', 'wimax'",
+                            examples="True",
+                            tests="True",
+                        )
+                    )
             # Reconfigure
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
-            self.config_ok(return_code, stdout)
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+            self.config_ok(return_code, stdout, stderr)
 
             # Check
             enabled_modules = get_enabled_modules()
@@ -1034,8 +1150,8 @@
             os.remove(ns3rc_script)
 
             # Reconfigure
-            return_code, stdout, stderr = run_ns3("configure -G \"{generator}\"")
-            self.config_ok(return_code, stdout)
+            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+            self.config_ok(return_code, stdout, stderr)
 
             # Check
             self.assertEqual(len(get_enabled_modules()), len(self.ns3_modules))
@@ -1061,7 +1177,7 @@
         run_ns3("clean")
 
         # Build target before using below
-        run_ns3("configure -G \"{generator}\" -d release --enable-verbose")
+        run_ns3('configure -G "{generator}" -d release --enable-verbose')
         run_ns3("build scratch-simulator")
 
         # Run all cases and then check outputs
@@ -1107,7 +1223,7 @@
         return_code, _, _ = run_ns3("clean")
         self.assertEqual(return_code, 0)
 
-        return_code, _, _ = run_ns3("configure -G \"{generator}\" --enable-examples --enable-tests")
+        return_code, _, _ = run_ns3('configure -G "{generator}" --enable-examples --enable-tests')
         self.assertEqual(return_code, 0)
 
         # Build necessary executables
